#include "entier.h"
#include <iostream>
using std::istream;
using std::ostream;
#include <algorithm>
using std::copy;
#include <iterator>
using std::ostream_iterator;

ostream & operator<< (ostream &os, const entier &e)
{
   std::ios_base::fmtflags fmt = os.flags ();
   std::noboolalpha (os);
   copy (e.rbegin (), e.rend(), ostream_iterator <entier::ConstBit>(os, " "));
   os.flags (fmt);
   return os;
}

istream & operator>> (istream &is, entier &e)
{
   if (is)
   {
      std::ios_base::fmtflags fmt = is.flags ();
      std::noboolalpha (is);
      int bit;
      for (int i = 0; i < entier::nbits && is >> (bit); e[entier::nbits - ++i] = bit)
         ;
      is.flags (fmt);
   }
   return is;
}

namespace std
{
   template <>
      void iter_swap (entier::iterator a, entier::iterator b)
   {
      a.swap (b);
   }
   template <>
      void iter_swap (entier::reverse_iterator a, entier::reverse_iterator b)
   {
      a.swap (b);
   }
}

