#ifndef RELATIONS_H
#define RELATIONS_H

namespace relation
{
   template <class T>
      struct equivalence
      {
         friend bool operator!= (const T &a, const T &b)
            { return ! (a == b); }
         template <class U>
            friend bool operator!= (const T &a, const U &b)
               { return ! (a == b); }
         template <class U>
            friend bool operator!= (const U &a, const T &b)
               { return ! (a == b); }
      };
   template <class T>
      struct ordonnancement
      {
         friend bool operator<= (const T &a, const T &b)
            { return ! (b < a); }
         friend bool operator> (const T &a, const T &b)
            { return b < a; }
         friend bool operator>= (const T &a, const T &b)
            { return !(a < b); }
      };
   template <class T>
      struct logique
      {
         template <class U>
            friend bool operator && (const U &b, const T &a)
               { return a && b; }
         template <class U>
            friend bool operator || (const U &b, const T &a)
               { return a || b; }
      };
   template <class T, class R = int>
      struct bit_a_bit
      {
         template <class U>
            friend R operator & (const U &b, const T &a)
               { return a & b; }
         template <class U>
            friend R operator | (const U &b, const T &a)
               { return a | b; }
         template <class U>
            friend R operator ^ (const U &b, const T &a)
               { return a ^ b; }
      };
}

#endif